<?php
session_start();

header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] !== 'GET') {
    http_response_code(405); 
    echo json_encode(['status' => 'error', 'message' => 'Method Not Allowed']);
    exit;
}

$caller = isset($_GET['caller']) ? $_GET['caller'] : '';
$phoneno = isset($_GET['phoneno']) ? $_GET['phoneno'] : '';
$user_id = 'af_159682';

if (empty($caller) || empty($phoneno) ) {
    http_response_code(400); 
    echo json_encode(['status' => 'error', 'message' => 'Missing parameters']);
    exit;
}

$callData = [
    'caller' => $caller,
    'phoneno' => $phoneno,
    'timestamp' => date('Y-m-d H:i:s'),
    'user_tenant_id' =>$user_id
];
file_put_contents('call_log_aOne.txt', print_r($callData, true), FILE_APPEND);

$filename = 'call_data_Aone.json';
$currentData = file_exists($filename) ? json_decode(file_get_contents($filename), true) : [];
$currentData[] = $callData;
file_put_contents($filename, json_encode($currentData));

echo json_encode(['status' => 'success']);
?>
