<?php
session_start();
include '../db/db.php'; // Ensure the database connection file is correctly included

$user_id = $_SESSION['user_tenant_id']; // Safely retrieve the session variable

if ($user_id && isset($_POST['state'])) { // Validate session and POST input
    $state = $_POST['state'];

    // Use a prepared statement to prevent SQL injection
    $query = "UPDATE auto_dispatch SET state = ? WHERE user_tenant_id = ?";
    $stmt = $con->prepare($query);

    if ($stmt) {
        $stmt->bind_param("is", $state, $user_id); // Bind state (int) and user_id (string)

        if ($stmt->execute()) {
            echo "success"; // Indicate success
        } else {
            echo "error: " . $stmt->error; // Provide error details for debugging
        }

        $stmt->close();
    } else {
        echo "error: Unable to prepare statement"; // Handle prepare failure
    }

    $con->close();
} else {
    echo "error: Invalid input"; // Handle missing session or POST data
}
?>
