<?php
// Include your database connection
session_start();
include '../db/db.php';

header('Content-Type: application/json'); // Set the header for JSON response

$response = [];

// Validate session variables
if (!isset($_SESSION['user_tenant_id']) || !isset($_SESSION['username'])) {
    $response['status'] = 'error';
    $response['message'] = 'User session data is missing.';
    echo json_encode($response);
    exit;
}

$user_id = $_SESSION['user_tenant_id'];
$username = htmlspecialchars($_SESSION['username'], ENT_QUOTES, 'UTF-8');

// Set timezone
$timezone = 'Europe/London';
date_default_timezone_set($timezone);
if (isset($_REQUEST['timezone']) && in_array($_REQUEST['timezone'], timezone_identifiers_list())) {
    $timezone = $_REQUEST['timezone'];
    date_default_timezone_set($timezone);
}

$currentDateTime = date('d/m/Y H:i');  
$currentDate = date('m/d/Y');
$currentTime = date('H:i');

// Check the auto_dispatch state
$dispatch_query = "SELECT * FROM `auto_dispatch` WHERE user_tenant_id ='$user_id'";
$dispatch_result = mysqli_query($con, $dispatch_query);

if (!$dispatch_result) {
    $response['status'] = 'error';
    $response['message'] = 'Failed to fetch auto_dispatch state.';
    echo json_encode($response);
    exit;
}

$dispatch_row = mysqli_fetch_assoc($dispatch_result);
$state = $dispatch_row['state'];

if ($state === '1') {
    // Select jobs for dispatch
    $job_query = "SELECT * FROM bookins WHERE date='$currentDate' AND status='' AND accepted='' AND allocate_DriverId IS NOT NULL AND allocate_DriverId != ''  AND user_tenant_id ='$user_id'";
    $job_result = mysqli_query($con, $job_query);

    if (mysqli_num_rows($job_result) > 0) {
        while ($job_row = mysqli_fetch_assoc($job_result)) {
            $id = $job_row['id'];
            $allocate_driver_Id = $job_row['allocate_DriverId'];

            // Update the bookins table
            $update_query = "UPDATE `bookins` SET 
                             `dispatch_DriverId` = '$allocate_driver_Id',
                             `allocate_DriverId` = '$allocate_driver_Id-waiting',
                             `dispatch_time` = '$currentDateTime',
                             `dispatch_by` = '$username'
                             WHERE `id` = '$id' AND `lead_time` = '$currentTime' AND user_tenant_id ='$user_id'";

            if (mysqli_query($con, $update_query)) {
                $response['status'] = 'success';
                $response['message'][] = "Job ID $id updated successfully.";
            } else {
                $response['status'] = 'error';
                $response['message'][] = "Failed to update Job ID $id.";
            }
        }
    } else {
        $response['status'] = 'no_jobs';
        $response['message'] = "No jobs to dispatch for today.";
    }
} else {
    $response['status'] = 'off';
    $response['message'] = "Auto dispatch is turned off.";
}

// Return the JSON response
echo json_encode($response);
mysqli_close($con);
