<?php
session_start();
include("../db/db.php");

// Check session
if (!isset($_SESSION['user_tenant_id'])) {
    die(json_encode(array('success' => false, 'message' => 'User session is not set.')));
}

$user_id = $_SESSION['user_tenant_id'];

// Check database connection
if (!$con) {
    die(json_encode(array('success' => false, 'message' => 'Database connection failed: ' . mysqli_connect_error())));
}

// Build query
$query = "SELECT bookins.id, bookins.pickup, bookins.dropoff, bookins.via, bookins.status, drivers.Driver_id, drivers.Make_By, drivers.Car_Type, drivers.Phone, drivers.Color, drivers.Car_Model, drivers.Registration
          FROM bookins
          INNER JOIN drivers ON bookins.dispatch_DriverId = drivers.Driver_id
          WHERE (bookins.status = '' OR bookins.status = 'At Pickup' OR bookins.status = 'Passenger On Board' OR bookins.status = 'On Route To The Destination' OR bookins.status = 'Soon To Clear')
          AND accepted = '1'
          AND bookins.user_tenant_id = '$user_id'
          AND drivers.user_tenant_id='$user_id'";
          
// Debug the query
error_log("Executing Query: $query");

// Execute query
$result = mysqli_query($con, $query);

if ($result) {
    $data = array();

    // Fetch the data
    while ($row = mysqli_fetch_assoc($result)) {
        $data[] = $row;
    }

    mysqli_free_result($result);

    // Return the data as JSON
    header('Content-Type: application/json');
    echo json_encode(array('success' => true, 'data' => $data), JSON_PRETTY_PRINT);
} else {
    // Handle the error
    echo json_encode(array('success' => false, 'message' => 'Error executing query: ' . mysqli_error($con)));
}

mysqli_close($con);
?>
