<?php
session_start();
include("../db/db.php");
$user_id= $_SESSION['user_tenant_id'];
header('Content-Type: application/json');

function isPointInPolygon($latitude, $longitude, $polygon) {
    $intersections = 0;
    $pointsCount = count($polygon);

    for ($i = 0, $j = $pointsCount - 1; $i < $pointsCount; $j = $i++) {
        $lat1 = $polygon[$i]['lat'];
        $lng1 = $polygon[$i]['lng'];
        $lat2 = $polygon[$j]['lat'];
        $lng2 = $polygon[$j]['lng'];

        // Check if the point is on an edge or crosses the polygon edge
        if ((($lng1 > $longitude) != ($lng2 > $longitude)) &&
            ($latitude < ($lat2 - $lat1) * ($longitude - $lng1) / ($lng2 - $lng1) + $lat1)) {
            $intersections++;
        }
    }
    return ($intersections % 2) != 0;
}

// Fetch all polygons (plots) from the database
$plotQuery = "SELECT * FROM plot";
$plotResult = mysqli_query($con, $plotQuery);

$plots = [];
while ($plotRow = mysqli_fetch_assoc($plotResult)) {
    $polygon = json_decode($plotRow['Area'], true);
    if (json_last_error() === JSON_ERROR_NONE) {
        $plots[] = [
            'id' => $plotRow['id'],
            'name' => $plotRow['Name'],
            'polygon' => $polygon
        ];
    } else {
        error_log('JSON decode error: ' . json_last_error_msg());
    }
}

// Fetch drivers with their coordinates
$driverQuery = "SELECT * FROM drivers WHERE plot = 'plot' AND logout = '' AND user_tenant_id='$user_id' ORDER BY position";
$driverResult = mysqli_query($con, $driverQuery);

$drivers = [];
while ($driverRow = mysqli_fetch_assoc($driverResult)) {
    $driverLatitude = floatval($driverRow['latitude']);
    $driverLongitude = floatval($driverRow['longitude']);
    $zoneName = 'Unknown Zone';

    foreach ($plots as $plot) {
        if (isPointInPolygon($driverLatitude, $driverLongitude, $plot['polygon'])) {
            $zoneName = $plot['name'];
            break;
        }
    }

    $driverRow['zone_name'] = $zoneName;
    $drivers[] = $driverRow;
}

echo json_encode(['success' => true, 'data' => $drivers]);
mysqli_close($con);
?>
