<?php
session_start();
include("../db/db.php");

if ($_SERVER['REQUEST_METHOD'] == "POST") {
    $user_id = $_SESSION['user_tenant_id'];
    $pick = mysqli_real_escape_string($con, $_REQUEST['pickup']);
    $drop = mysqli_real_escape_string($con, $_REQUEST['drop']);
    $via = mysqli_real_escape_string($con, isset($_REQUEST['via']) ? $_REQUEST['via'] : '');
    $viaTwo = mysqli_real_escape_string($con, isset($_REQUEST['viaTwo']) ? $_REQUEST['viaTwo'] : '');
    $distance = mysqli_real_escape_string($con, $_REQUEST['distance']);
    $fare = mysqli_real_escape_string($con, $_REQUEST['fare']);
    $carType = mysqli_real_escape_string($con, $_REQUEST['carType']);
    $pax = mysqli_real_escape_string($con, isset($_REQUEST['pax']) ? $_REQUEST['pax'] : '');
    $luggage = mysqli_real_escape_string($con, isset($_REQUEST['luggage']) ? $_REQUEST['luggage'] : '');
    $routeSelect = mysqli_real_escape_string($con, $_REQUEST['routeSelect']);
    $returnTimes = isset($_REQUEST['returnTimes']) ? $_REQUEST['returnTimes'] : [];
    $times = isset($_REQUEST['times']) ? $_REQUEST['times'] : []; // Array of times
    $returnTimes = isset($_REQUEST['returnTimes']) ? $_REQUEST['returnTimes'] : []; // Array of return times
    $isReturnTrip = isset($_REQUEST['isReturnTrip']) ? $_REQUEST['isReturnTrip'] : false;
    $name = mysqli_real_escape_string($con, $_REQUEST['name']);
    $email = mysqli_real_escape_string($con, $_REQUEST['email']);
    $phone = mysqli_real_escape_string($con, $_REQUEST['phone']);
    $message = mysqli_real_escape_string($con, $_REQUEST['message']);
    $job_type = mysqli_real_escape_string($con, $_REQUEST['jobtype']);
    $payment_type = mysqli_real_escape_string($con, $_REQUEST['Payment_Type']);
    $account = mysqli_real_escape_string($con, isset($_REQUEST['Account']) ? $_REQUEST['Account'] : '');
    $DriverID = mysqli_real_escape_string($con, isset($_REQUEST['driverId']) ? $_REQUEST['driverId'] : '');
    $pickupLatLon = mysqli_real_escape_string($con, isset($_REQUEST['pickupLatLon']) ? $_REQUEST['pickupLatLon'] : '');
    $dropLatLon = mysqli_real_escape_string($con, isset($_REQUEST['dropLatLon']) ? $_REQUEST['dropLatLon'] : '');
    $oneWayDates = isset($_REQUEST['oneWayDates']) ? $_REQUEST['oneWayDates'] : [];
    $returnDates = isset($_REQUEST['returnDates']) ? $_REQUEST['returnDates'] : [];

    function convertToUSDateFormat($dates) {
        $convertedDates = [];
        foreach ($dates as $date) {
            $dateParts = explode('/', $date); // Split the date into parts
            if (count($dateParts) === 3) {
                $convertedDates[] = $dateParts[1] . '/' . $dateParts[0] . '/' . $dateParts[2]; // Rearrange to mm/dd/YYYY
            }
        }
        return $convertedDates;
    }
    $oneWayDatesUSFormat = convertToUSDateFormat($oneWayDates);
    $returnDatesUSFormat = convertToUSDateFormat($returnDates);


    $daysCount = isset($_REQUEST['daysCount']) ? intval($_REQUEST['daysCount']) : 1;

    $successCount = 0;

    // Debugging: print days count and times array
    error_log("Days Count: " . $daysCount);
    error_log("Times Array: " . json_encode($times));
    error_log("Return Times Array: " . json_encode($returnTimes));

    // Loop to save one-way trips
   // Loop through the converted dates array to save the jobs
        foreach ($oneWayDatesUSFormat as $i => $jobDate) {
            // Use the $i index to access corresponding times from the $times array if available
            $time = isset($times[$i]) ? mysqli_real_escape_string($con, $times[$i]) : ''; // Get time from array or default to empty
        
            if ($time === '') {
                echo json_encode(['error' => "Time is missing for date " . $jobDate . "."]);
                exit;
            }
        
            // Prepare the INSERT query for each job date
            $query = "INSERT INTO `bookins`(
                        `pickup`, `via`, `via_Two`, `dropoff`, `distance`, `fare`, `car_type`, 
                        `pax`, `luggage`, `routeSelect`, `date`, `time`, `name`, `email`, 
                        `phone`, `message`, `type`, `payment_type`, `account`, 
                        `allocate_driverId`, `pickupLatLong`, `dropLatLong`, `user_tenant_id`
                      ) 
                      VALUES (
                        '$pick', '$via', '$viaTwo', '$drop', '$distance', '$fare', '$carType', 
                        '$pax', '$luggage', '$routeSelect', '$jobDate', '$time', '$name', 
                        '$email', '$phone', '$message', '$job_type', '$payment_type', 
                        '$account', '$DriverID', '$pickupLatLon', '$dropLatLon', '$user_id'
                      )";
        
          
            error_log("One-way Query for date $jobDate: " . $query);
        
           
            $result = mysqli_query($con, $query);
        
            if ($result !== false) {
                $successCount++;
            } else {
                error_log("Error in one-way query execution for date $jobDate: " . mysqli_error($con));
            }
        }
        
        if ($successCount === count($oneWayDatesUSFormat)) {
            echo json_encode(['success' => "All jobs have been saved successfully."]);
        } else {
            echo json_encode(['error' => "Some jobs could not be saved. Check logs for details."]);
        }

   if ($isReturnTrip == true) {
    foreach ($returnDatesUSFormat as $i => $retJobDate) {
      
        $returnTime = isset($returnTimes[$i]) ? mysqli_real_escape_string($con, $returnTimes[$i]) : '';
        if ($returnTime === '') {
            echo json_encode(['error' => "Return time is missing for date " . $retJobDate . "."]);
            exit;
        }

        // Prepare the INSERT query for each return job date
        $query = "INSERT INTO `bookins`(
                    `pickup`, `via`, `via_Two`, `dropoff`, `distance`, `fare`, `car_type`, 
                    `pax`, `luggage`, `routeSelect`, `date`, `time`, `name`, `email`, 
                    `phone`, `message`, `type`, `payment_type`, `account`, 
                    `allocate_driverId`, `pickupLatLong`, `dropLatLong`, `user_tenant_id`
                  ) 
                  VALUES (
                    '$drop', '$via', '$viaTwo', '$pick', '$distance', '$fare', '$carType', 
                    '$pax', '$luggage', '$routeSelect', '$retJobDate', '$returnTime', '$name', 
                    '$email', '$phone', '$message', '$job_type', '$payment_type', 
                    '$account', '$DriverID', '$dropLatLon', '$pickupLatLon', '$user_id'
                  )";

        // Debugging: print each query
        error_log("Return Query for date $retJobDate: " . $query);

        // Execute the query
        $result = mysqli_query($con, $query);

        if ($result !== false) {
            $successCount++;
        } else {
            // Log the error in case the query fails
            error_log("Error in return query execution for date $retJobDate: " . mysqli_error($con));
        }
    }
}

// Check if all jobs (one-way and return) are saved
$totalJobs = count($oneWayDatesUSFormat) + ($isReturnTrip ? count($returnDatesUSFormat) : 0);
if ($successCount == $totalJobs) {
    echo json_encode(['success' => "Job(s) saved successfully!"]);
} else {
    echo json_encode(['error' => "Only $successCount out of $totalJobs job(s) were saved."]);
}

}
?>
