<?php
session_start();
$googleApiKey = 'AIzaSyBrT6TBKJor6uQd0OKXKzLnpkKY5JniO4M'; // Replace with your actual Google Maps API key

function geocodeAddress($address, $apiKey) {
    $url = "https://maps.googleapis.com/maps/api/geocode/json?address=" . urlencode($address) . "&key=" . $apiKey;

    // Log the URL for debugging
    error_log("Geocoding URL: $url");

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $response = curl_exec($ch);
    curl_close($ch);

    $responseData = json_decode($response, true);

    // Log the response for debugging
    error_log("Geocoding Response for '$address': " . print_r($responseData, true));

    if (isset($responseData['results']) && count($responseData['results']) > 0) {
        return [
            'latitude' => $responseData['results'][0]['geometry']['location']['lat'], 
            'longitude' => $responseData['results'][0]['geometry']['location']['lng'] 
        ];
    }

    return ['latitude' => null, 'longitude' => null];
}

include("../db/db.php");

if (isset($_GET['jobId'])) {
    $jobId = $_GET['jobId'];
    $user_id = $_SESSION['user_tenant_id'];

    $driverQuery = "SELECT dispatch_DriverId FROM bookins WHERE id = ? AND user_tenant_id = ?";
    $stmt = mysqli_prepare($con, $driverQuery);
    mysqli_stmt_bind_param($stmt, "is", $jobId, $user_id);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $driverId);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    // Fetch driver's latitude and longitude from the drivers table
    $query = "SELECT latitude, longitude, Registration, Phone, Make_By, Car_Model, Color, Driver_id FROM drivers WHERE Driver_id = ? AND user_tenant_id = ?";
    $stmt = mysqli_prepare($con, $query);
    mysqli_stmt_bind_param($stmt, "is", $driverId, $user_id);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $driverLatitude, $driverLongitude, $registration, $phone, $make, $model, $color, $driverId);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    $jobQuery = "SELECT pickup, dropoff FROM bookins WHERE id = ? AND user_tenant_id = ?";
    $stmt = mysqli_prepare($con, $jobQuery);
    mysqli_stmt_bind_param($stmt, "is", $jobId, $user_id);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $pickupName, $dropoffName);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    // Log the pickup and dropoff addresses for debugging
    error_log("Pickup Address: $pickupName");
    error_log("Dropoff Address: $dropoffName");

    // Geocode pickup and dropoff locations
    $pickupCoordinates = geocodeAddress($pickupName, $googleApiKey);
    $dropoffCoordinates = geocodeAddress($dropoffName, $googleApiKey);

    // Check if geocoding was successful
    if ($pickupCoordinates['latitude'] !== null && $dropoffCoordinates['latitude'] !== null) {
        // Prepare response with valid coordinates
        $pickupLatitude = $pickupCoordinates['latitude'];
        $pickupLongitude = $pickupCoordinates['longitude'];
        $dropoffLatitude = $dropoffCoordinates['latitude'];
        $dropoffLongitude = $dropoffCoordinates['longitude'];
    } else {
        // Handle case where geocoding failed
        error_log("Geocoding failed for pickup: '$pickupName' or dropoff: '$dropoffName'");
        $pickupLatitude = $pickupLongitude = $dropoffLatitude = $dropoffLongitude = null;
    }

    // Close the database connection
    mysqli_close($con);

    // Output driver and job details as JSON
    if (isset($driverLatitude) && isset($driverLongitude) && isset($pickupLatitude)) {
        $responseData = [
            'driverLatitude' => $driverLatitude,
            'driverLongitude' => $driverLongitude,
            'pickupLatitude' => $pickupLatitude,
            'pickupLongitude' => $pickupLongitude,
            'dropoffLatitude' => $dropoffLatitude,
            'dropoffLongitude' => $dropoffLongitude,
            'carModel' => $model,
            'registration' => $registration,
            'phone' => $phone,
            'make' => $make,
            'color' => $color,
            'driverId' => $driverId,
            'pickup' => $pickupName,
            'dropoff' => $dropoffName
        ];
    } else {
        error_log("Required driver or location data is missing for jobId: $jobId");
        $responseData = []; //
    }

    echo json_encode($responseData);
}
?>
