<?php
// webhook.php

header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] !== 'POST') {
    http_response_code(405); // Method Not Allowed
    echo json_encode(['status' => 'error', 'message' => 'Method Not Allowed']);
    exit;
}

$postData = file_get_contents('php://input');
$callData = json_decode($postData, true);

// Check if JSON is valid
if (json_last_error() !== JSON_ERROR_NONE) {
    http_response_code(400); // Bad Request
    echo json_encode(['status' => 'error', 'message' => 'Invalid JSON']);
    exit;
}

// Log the incoming call data (for debugging)
file_put_contents('call_log.txt', print_r($callData, true), FILE_APPEND);


session_start();
if (isset($_SESSION['user_tenant_id'])) {
    $userTenantId = $_SESSION['user_tenant_id'];  // Get the session user_tenant_id
} else {
  
    $userTenantId = 'ae_145698'; 
}


$callData['user_tenant_id'] = $userTenantId;


if (isset($callData['call_type']) && $callData['call_type'] === 'inbound') {
    $filename = 'call_data.json';
    $currentData = file_exists($filename) ? json_decode(file_get_contents($filename), true) : [];
    

    $currentData[] = $callData;
    

    file_put_contents($filename, json_encode($currentData));
}


echo json_encode(['status' => 'success']);
?>
