<?php
include("../db/db.php");

header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    if (empty($_POST['id']) || empty($_POST['user_tenant_id'])) {
        echo json_encode([
            'success' => false,
            'message' => 'Please provide all required parameters: id and user_tenant_id'
        ]);
        exit;
    }

    $id = isset($_POST['id']) ? $_POST['id'] : null;
    $user_id = isset($_POST['user_tenant_id']) ? $_POST['user_tenant_id'] : null;

    if ($id !== null) {
        $currentDate = date('m/d/Y'); // Today's date
        $currentTime = date('H:i'); // Current time
        $oneHourBefore = date('H:i', strtotime('-1 hour')); // One hour before the current time
        $oneHourAfter = date('H:i', strtotime('+1 hour')); // One hour after the current time

        // Adjust the query to filter by time
        $query = "
            SELECT * 
            FROM bookins 
            WHERE 
                dispatch_DriverId = '$id' 
                AND date = '$currentDate' 
                AND (
                    time >= '$oneHourBefore' 
                    AND time <= '$oneHourAfter'
                )
                AND (
                    status = '' 
                    OR status = 'At Pickup' 
                    OR status = 'Passenger On Board' 
                    OR status = 'On Route To The Destination' 
                    OR status = 'Soon To Clear'
                ) 
                AND user_tenant_id = '$user_id'
        ";

        $result = mysqli_query($con, $query);

        if ($result) {
            $data = array();
            while ($row = mysqli_fetch_assoc($result)) {
                $data[] = $row;
            }

            if (count($data) > 0) {
                echo json_encode(array('success' => true, 'data' => $data));
            } else {
                echo json_encode(array('success' => false, 'message' => 'No job available'));
            }

            mysqli_free_result($result);
        } else {
            echo json_encode(array('success' => false, 'message' => 'Error executing query: ' . mysqli_error($con)));
        }
    } else {
        echo json_encode(array('success' => false, 'message' => 'Please provide a driver ID'));
    }
} else {
    echo json_encode(array('success' => false, 'message' => 'Invalid request method'));
}

mysqli_close($con);
?>
