<?php
include("../db/db.php");

header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] == "POST" && isset($_POST['driverId'])) {
    $selectedDriver = mysqli_real_escape_string($con, $_POST['driverId']);
    $user_id = mysqli_real_escape_string($con, $_POST['user_tenant_id']);
    $date = mysqli_real_escape_string($con, $_POST['date']);
    $fromDate = mysqli_real_escape_string($con, $_POST['fromDate']);
    $toDate = mysqli_real_escape_string($con, $_POST['toDate']);
    
    
    if (empty($date) && empty($fromDate) && empty($toDate)) {
        $loginQuery = "SELECT login_time FROM drivers 
                       WHERE Driver_id = '$selectedDriver' AND user_tenant_id = '$user_id' 
                       ORDER BY login_time DESC LIMIT 1";
        $loginResult = mysqli_query($con, $loginQuery);
        
        if ($loginResult && mysqli_num_rows($loginResult) > 0) {
            $loginData = mysqli_fetch_assoc($loginResult);
            $fromTime = $loginData['login_time']; 
            $toTime = date('H:i:s'); 
            

            $sql = "SELECT 
                        drivers.Driver_id, 
                        drivers.Name,
                        drivers.paymentType AS Payment_Type,
                        drivers.payment AS Commission_Percentage,
                        COUNT(bookins.id) AS total_jobs_completed,
                        SUM(bookins.fare) AS total_earned,
                        SUM(CASE WHEN bookins.payment_type = 'Cash' THEN 1 ELSE 0 END) AS total_cash_jobs_count,
                        SUM(CASE WHEN bookins.payment_type = 'Cash' THEN bookins.fare ELSE 0 END) AS total_cash_jobs_amount,
                        SUM(CASE WHEN bookins.payment_type = 'Card' THEN 1 ELSE 0 END) AS total_card_jobs_count,
                        SUM(CASE WHEN bookins.payment_type = 'Card' THEN bookins.fare ELSE 0 END) AS total_card_jobs_amount,
                        SUM(CASE WHEN bookins.payment_type = 'Account' THEN 1 ELSE 0 END) AS total_account_jobs_count,
                        SUM(CASE WHEN bookins.payment_type = 'Account' THEN bookins.fare ELSE 0 END) AS total_account_jobs_amount,
                        SUM(CASE WHEN drivers.paymentType = 'Commission' THEN (bookins.fare * drivers.payment / 100) ELSE 0 END) AS commission_amount
                    FROM
                        drivers
                    LEFT JOIN
                        bookins ON drivers.Driver_id = bookins.dispatch_DriverId
                        AND bookins.status = 'completed'
                        AND bookins.user_tenant_id = '$user_id'
                        AND STR_TO_DATE(bookins.date, '%m/%d/%Y') = CURDATE()
                    WHERE
                        drivers.Driver_id = '$selectedDriver'
                        AND drivers.user_tenant_id = '$user_id'
                    GROUP BY
                        drivers.Driver_id
                    ORDER BY
                        total_jobs_completed DESC";
        } else {
            echo json_encode(['error' => 'Failed to retrieve login time for the driver.']);
            exit;
        }
    } else {
    
       $sql = "SELECT 
            drivers.Driver_id, 
            drivers.Name,
            drivers.paymentType AS Payment_Type,
            drivers.payment AS Commission_Percentage,
            COUNT(bookins.id) AS total_jobs_completed,
            SUM(bookins.fare) AS total_earned,
            SUM(CASE WHEN bookins.payment_type = 'Cash' THEN 1 ELSE 0 END) AS total_cash_jobs_count,
            SUM(CASE WHEN bookins.payment_type = 'Cash' THEN bookins.fare ELSE 0 END) AS total_cash_jobs_amount,
            SUM(CASE WHEN bookins.payment_type = 'Card' THEN 1 ELSE 0 END) AS total_card_jobs_count,
            SUM(CASE WHEN bookins.payment_type = 'Card' THEN bookins.fare ELSE 0 END) AS total_card_jobs_amount,
            SUM(CASE WHEN bookins.payment_type = 'Account' THEN 1 ELSE 0 END) AS total_account_jobs_count,
            SUM(CASE WHEN bookins.payment_type = 'Account' THEN bookins.fare ELSE 0 END) AS total_account_jobs_amount,
            SUM(CASE WHEN drivers.paymentType = 'Commission' THEN (bookins.fare * drivers.payment / 100) ELSE 0 END) AS commission_amount
        FROM
            drivers
        LEFT JOIN
            bookins ON drivers.Driver_id = bookins.dispatch_DriverId
            AND bookins.status = 'completed'
            AND bookins.user_tenant_id = '$user_id'
            AND (STR_TO_DATE(bookins.date, '%m/%d/%Y') = STR_TO_DATE('$date', '%m/%d/%Y') OR 
                 (STR_TO_DATE(bookins.date, '%m/%d/%Y') BETWEEN STR_TO_DATE('$fromDate', '%m/%d/%Y') 
                 AND STR_TO_DATE('$toDate', '%m/%d/%Y')))
        WHERE
            drivers.Driver_id = '$selectedDriver'
            AND drivers.user_tenant_id = '$user_id'
        GROUP BY
            drivers.Driver_id
        ORDER BY
            total_jobs_completed DESC";

    }

    $result = mysqli_query($con, $sql);

    if (!$result) {
        echo json_encode(['error' => 'Query failed: ' . mysqli_error($con)]);
        exit;
    }

    $dataArray = array();

    while ($data = mysqli_fetch_assoc($result)) {
        $row = array(
            'Driver_id' => $data['Driver_id'],
            'Name' => $data['Name'],
            'Payment_Type' => $data['Payment_Type'],
            'Commission_Percentage' => $data['Commission_Percentage'] . '%',
            'total_jobs_completed' => $data['total_jobs_completed'],
            'total_earned' => '£' . number_format($data['total_earned'], 2),
            'total_cash_jobs_count' => $data['total_cash_jobs_count'],
            'total_cash_jobs_amount' => '£' . number_format($data['total_cash_jobs_amount'], 2),
            'total_card_jobs_count' => $data['total_card_jobs_count'],
            'total_card_jobs_amount' => '£' . number_format($data['total_card_jobs_amount'], 2),
            'total_account_jobs_count' => $data['total_account_jobs_count'],
            'total_account_jobs_amount' => '£' . number_format($data['total_account_jobs_amount'], 2),
            'commission_amount' => '£' . number_format($data['commission_amount'], 2)
        );

        $dataArray[] = $row;
    }
    
    echo json_encode(['Success' => 'true', 'data' => $dataArray]);
} else {
    echo json_encode(['error' => 'Invalid request method or missing driver parameter.']);
}
?>
