<?php
include("../db/db.php");

header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    $json_data = file_get_contents('php://input');
    $data = json_decode($json_data, true);

    $user_id = isset($data['user_tenant_id']) ? $data['user_tenant_id'] : null;
    $driver_id = isset($data['driverId']) ? $data['driverId'] : null;

    // Validate common parameters
    if (empty($user_id) || empty($driver_id)) {
        echo json_encode(['success' => false, 'message' => 'Please provide driver ID and user_tenant_id']);
        exit;
    }

    $response = [
        'success' => true,
        'currentJob' => [
            'data' => [],
            'message' => ''
        ],
        'preBooking' => [
            'data' => [],
            'message' => ''
        ],
        'forceLogout' => null
    ];

    // Get the current date and time
    $currentDate = date('m/d/Y');
    $currentTime = date('H:i');

    // Current jobs
    $oneHourBefore = date('H:i', strtotime('-1 hour'));
    $oneHourAfter = date('H:i', strtotime('+1 hour'));

    $query = "
        SELECT * 
        FROM bookins 
        WHERE 
            dispatch_DriverId = '$driver_id' 
            AND date = '$currentDate' 
            AND (
                time >= '$oneHourBefore' 
                AND time <= '$oneHourAfter'
            )
            AND (
                status = '' 
                OR status = 'At Pickup' 
                OR status = 'Passenger On Board' 
                OR status = 'On Route To The Destination' 
                OR status = 'Soon To Clear'
            ) 
            AND user_tenant_id = '$user_id'
    ";

    $result = mysqli_query($con, $query);
    if ($result) {
        while ($row = mysqli_fetch_assoc($result)) {
            $response['currentJob']['data'][] = $row;
        }
        if (empty($response['currentJob']['data'])) {
            $response['currentJob']['message'] = 'No current jobs available';
        }
        mysqli_free_result($result);
    }

    // Prebooking jobs
    $thresholdTime = date('H:i', strtotime('+20 minutes'));
    $tomorrow = date('m/d/Y', strtotime('+1 day'));

    $query = "
        SELECT * 
        FROM bookins 
        WHERE 
            dispatch_DriverId = '$driver_id' 
            AND user_tenant_id = '$user_id' 
            AND (
                (date = '$tomorrow') 
                OR (date = '$currentDate' AND time > '$thresholdTime')
            )
            AND (status = '' OR status = 'At Pickup' OR status = 'Passenger On Board' OR status = 'On Route To The Destination')
    ";

    $result = mysqli_query($con, $query);
    if ($result) {
        while ($row = mysqli_fetch_assoc($result)) {
            $response['preBooking']['data'][] = $row;
        }
        if (empty($response['preBooking']['data'])) {
            $response['preBooking']['message'] = 'No pre-bookings available';
        }
        mysqli_free_result($result);
    }

    // Force logout
    $query = "SELECT logout FROM drivers WHERE Driver_id = '$driver_id' AND user_tenant_id = '$user_id'";
    $result = mysqli_query($con, $query);
    if ($result && mysqli_num_rows($result) > 0) {
        $row = mysqli_fetch_assoc($result);
        $response['forceLogout'] = $row['logout'];
    } else {
        $response['forceLogout'] = 'Driver ID not available for force logout';
    }

    echo json_encode($response);
} else {
    echo json_encode(['success' => false, 'message' => 'Invalid request method']);
}

mysqli_close($con);
?>
