<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);

include("../db/db.php");

define("FIREBASE_SERVER_KEY", "AIzaSyBBk6Vs7Gy0v9ikN7eB6g7OTy6OMv4C25M"); // Not used in HTTP v1
define("SERVICE_ACCOUNT_KEY_PATH", "minicaber-app-61cf4-firebase-adminsdk-ihhbt-dc90b54f08.json");

$currentDate = date('Y-m-d');

$query = "SELECT d.Driver_id, d.Name, d.token, d.License_Expiry_Date, d.PCO_License_Expiry_Date, 
                d.Vehicle_PCO_Expiry, d.MOT_Epiry, d.Insurance_Expiry, d.Road_Tax_Expiry
         FROM drivers d 
         WHERE (
             (d.License_Expiry_Date IS NOT NULL AND d.License_Expiry_Date != '' 
              AND DATE(STR_TO_DATE(d.License_Expiry_Date, '%d/%m/%Y')) = DATE_ADD('$currentDate', INTERVAL 3 DAY)) OR
             (d.PCO_License_Expiry_Date IS NOT NULL AND d.PCO_License_Expiry_Date != '' 
              AND DATE(STR_TO_DATE(d.PCO_License_Expiry_Date, '%d/%m/%Y')) = DATE_ADD('$currentDate', INTERVAL 3 DAY)) OR
             (d.MOT_Epiry IS NOT NULL AND d.MOT_Epiry != '' 
              AND DATE(STR_TO_DATE(d.MOT_Epiry, '%d/%m/%Y')) = DATE_ADD('$currentDate', INTERVAL 3 DAY)) OR
             (d.Insurance_Expiry IS NOT NULL AND d.Insurance_Expiry != '' 
              AND DATE(STR_TO_DATE(d.Insurance_Expiry, '%d/%m/%Y')) = DATE_ADD('$currentDate', INTERVAL 3 DAY)) OR
             (d.Vehicle_PCO_Expiry IS NOT NULL AND d.Vehicle_PCO_Expiry != '' 
              AND DATE(STR_TO_DATE(d.Vehicle_PCO_Expiry, '%d/%m/%Y')) = DATE_ADD('$currentDate', INTERVAL 3 DAY)) OR
             (d.Road_Tax_Expiry IS NOT NULL AND d.Road_Tax_Expiry != '' 
              AND DATE(STR_TO_DATE(d.Road_Tax_Expiry, '%d/%m/%Y')) = DATE_ADD('$currentDate', INTERVAL 3 DAY))
         ) AND d.token IS NOT NULL";

$result = mysqli_query($con, $query);

if (!$result) {
    die("Query failed: " . mysqli_error($con));
}

if (mysqli_num_rows($result) > 0) {
    while ($row = mysqli_fetch_assoc($result)) {
        $driverName = $row['Name'];
        $mobileToken = $row['token'];
        $expiringDocs = [];

        if (isDocumentExpiring($row['License_Expiry_Date'])) $expiringDocs[] = "Driver License";
        if (isDocumentExpiring($row['PCO_License_Expiry_Date'])) $expiringDocs[] = "Driver PCO";
        if (isDocumentExpiring($row['MOT_Epiry'])) $expiringDocs[] = "MOT Expiry";
        if (isDocumentExpiring($row['Insurance_Expiry'])) $expiringDocs[] = "Insurance Expiry";
        if (isDocumentExpiring($row['Vehicle_PCO_Expiry'])) $expiringDocs[] = "Vehicle PCO Expiry";
        if (isDocumentExpiring($row['Road_Tax_Expiry'])) $expiringDocs[] = "Road Tax Expiry";

        if (!empty($expiringDocs)) {
            $documentList = implode(", ", $expiringDocs);
            $notificationTitle = "Document Expiry Reminder";
            $notificationBody = "Hi $driverName, your $documentList will expire in 3 days. Please update them soon.";

            // Send push notification using HTTP v1
            $response = sendPushNotification($mobileToken, $notificationTitle, $notificationBody);
            error_log("Notification sent to $driverName: $response");
        }
    }
} else {
    error_log("No expiring documents found for the date: $currentDate");
    echo json_encode(["message" => "No expiring documents found."]);
}

function isDocumentExpiring($expiryDate)
{
    if (empty($expiryDate)) {
        return false;
    }

    $formattedExpiryDate = date('Y-m-d', strtotime(str_replace('/', '-', $expiryDate)));
    $threeDaysFromNow = date('Y-m-d', strtotime('+3 days'));

    return $formattedExpiryDate === $threeDaysFromNow;
}

function sendPushNotification($mobileToken, $title, $body)
{
    $serviceAccountKey = json_decode(file_get_contents(SERVICE_ACCOUNT_KEY_PATH), true);

    $now = time();
    $claims = [
        "iss" => $serviceAccountKey['client_email'],
        "sub" => $serviceAccountKey['client_email'],
        "aud" => "https://oauth2.googleapis.com/token",
        "iat" => $now,
        "exp" => $now + 3600,
        "scope" => "https://www.googleapis.com/auth/firebase.messaging"
    ];

    $jwtHeader = json_encode(['alg' => 'RS256', 'typ' => 'JWT']);
    $jwtPayload = json_encode($claims);

    $headerAndPayload = base64url_encode($jwtHeader) . "." . base64url_encode($jwtPayload);
    $signature = base64url_encode(signJWT($headerAndPayload, $serviceAccountKey['private_key']));

    $jwt = $headerAndPayload . "." . $signature;

    // Get OAuth2 token
    $ch = curl_init("https://oauth2.googleapis.com/token");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/x-www-form-urlencoded']);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query([
        'grant_type' => 'urn:ietf:params:oauth:grant-type:jwt-bearer',
        'assertion' => $jwt
    ]));

    $response = json_decode(curl_exec($ch), true);
    curl_close($ch);

    if (isset($response['access_token'])) {
        $fcmUrl = "https://fcm.googleapis.com/v1/projects/minicaber-app-61cf4/messages:send";
        $notification = [
            'message' => [
                'token' => $mobileToken,
                'notification' => ['title' => $title, 'body' => $body]
            ]
        ];

        $ch = curl_init($fcmUrl);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            'Authorization: Bearer ' . $response['access_token'],
            'Content-Type: application/json'
        ]);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($notification));

        $result = curl_exec($ch);
        curl_close($ch);

        return $result;
    }

    error_log("Failed to get access token: " . json_encode($response));
    return false;
}

function base64url_encode($data)
{
    return rtrim(strtr(base64_encode($data), '+/', '-_'), '=');
}

function signJWT($input, $privateKey)
{
    openssl_sign($input, $signature, $privateKey, OPENSSL_ALGO_SHA256);
    return $signature;
}
?>
