<?php
include("../db/db.php");
header("Content-Type: application/json");

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
  
    $driver_id = $_POST["driver_id"] ?? null;
    $user_id = $_POST['user_tenant_id'] ?? null;

    if (!$driver_id || !$user_id) {
        echo json_encode(["success" => false, "message" => "Missing driver_id or user_tenant_id."]);
        exit;
    }

    $uploadDir = "../assets/upload/";
    $fileFields = [
        "driver_image" => "Driver_image",
        "driver_license_image" => "License_Image",
        "vehicle_image" => "Vehicle_Image",
        "driver_pco_image" => "pco_image",
        "driver_insurence_image" => "ina_image",
        "veh_pco_image" => "veh_pco_image",
        "mot_image" => "mot_image",
        "road_image" => "road_image",
        "veh_insurence_image" => "veh_ins_image"
    ];

    $filePaths = [];
    $updates = [];

    // Fetch the existing driver data
    $selectQuery = "SELECT * FROM `drivers` WHERE `Driver_id` = '$driver_id' AND user_tenant_id = '$user_id'";
    $result = mysqli_query($con, $selectQuery);

    if (!$result || mysqli_num_rows($result) == 0) {
        echo json_encode(["success" => false, "message" => "Driver not found."]);
        exit;
    }

    $row = mysqli_fetch_assoc($result);

    // Process each file field
    foreach ($fileFields as $field => $dbColumn) {
        if (!empty($_FILES[$field]['name'])) {
            $filePath = $uploadDir . basename($_FILES[$field]['name']);

            // Remove the old file if exists
            if (!empty($row[$dbColumn]) && file_exists($row[$dbColumn])) {
                unlink($row[$dbColumn]);
            }

            // Move the uploaded file
            if (move_uploaded_file($_FILES[$field]['tmp_name'], $filePath)) {
                $filePaths[$field] = $filePath;
                $updates[] = "`$dbColumn` = '$filePath'";
            } else {
                echo json_encode(["success" => false, "message" => "Failed to upload $field."]);
                exit;
            }
        } else {
            $filePaths[$field] = $row[$dbColumn] ?? null;
        }
    }

    
    if (!empty($updates)) {
        $updateQuery = "UPDATE `drivers` SET " . implode(", ", $updates) . " WHERE `Driver_id` = '$driver_id' AND user_tenant_id = '$user_id'";
        $updateResult = mysqli_query($con, $updateQuery);

        if ($updateResult) {
            echo json_encode(["success" => true, "message" => "Documents updated successfully.", "files" => $filePaths]);
        } else {
            echo json_encode(["success" => false, "message" => "Failed to update the database."]);
        }
    } else {
        echo json_encode(["success" => true, "message" => "No files were updated."]);
    }
} else {
    echo json_encode(["success" => false, "message" => "Invalid request method."]);
}
?>
