document.addEventListener("DOMContentLoaded", function () {
  let map, directionsService, directionsRenderer;
  let markers = [];
    var inputDistance;

  function calculateDistanceAndFare() {
  
    // Retrieve location values from the form
    var pickup = $('#pickup').val();
    var drop = $('#drops').val();
    var carType = $('#cartype').val();
    var distance = $("#display_distance").val();
    var date = $("#dateInput").val();
    var time = $("#timeInput").val();
    var pickuplonlat = $("#pickupLocationLonLat").val();
    var dropofflonlat = $("#dropoffLocationLonLat").val();

    console.log("date", date);
    console.log("time", time);
    
    console.log("pickup", pickup);
    console.log("drop", drop);
    console.log("car", carType);
    console.log("distance", distance);
    
    
    if (pickup && drop) {
     
            $.ajax({
              type: 'POST',
              url: './action/Submit.php',
              data: {
                pickup: pickup,
                drop: drop,
                carType: carType,
                distance: distance,
                 date:date,
                time:time,
                pickuplonlat:pickuplonlat,
                dropofflonlat:dropofflonlat
              },
              cache: false,
              success: function (response) {
                
                console.log("price", response);
                $('#priceVal').val( response);

              },
              error: function () {
                console.log("error")
              }
            });
          } else {
          console.log("add locations")
          }
  }
    // Add event listeners to car type, pickup location, and drop location inputs
    $('#cartype, #pickup, #drops, .via').on('input change', function () {
      calculateDistanceAndFare();
    });
  
    // Initially, calculate the fare based on the initial values if both locations are provided
    calculateDistanceAndFare();
  
  function initMap() {
    map = new google.maps.Map(document.getElementById('map'), {
      zoom: 7,
      center: { lat: 51.5074, lng: -0.1278 },
    });

    directionsService = new google.maps.DirectionsService();
    directionsRenderer = new google.maps.DirectionsRenderer({
      map: map,
      suppressMarkers: true,
    });

    const pickupInput = document.getElementById('pickup');
    const pickupAutocomplete = new google.maps.places.Autocomplete(pickupInput);

    const viaInput = document.getElementById('via');
    const viaAutocomplete = new google.maps.places.Autocomplete(viaInput);

    const viaInputTwo = document.getElementById('viaTwo');
    const viaTwoAutocomplete = new google.maps.places.Autocomplete(viaInputTwo);
    
     const viaInputThree = document.getElementById('viaThree');
    const viaThreeAutocomplete = new google.maps.places.Autocomplete(viaInputThree);

    const viaInputFour = document.getElementById('viaFour');
    const viaFourAutocomplete = new google.maps.places.Autocomplete(viaInputFour);

    const dropInput = document.getElementById('drops');
    const dropAutocomplete = new google.maps.places.Autocomplete(dropInput);

    pickupAutocomplete.addListener('place_changed', function () {
      calculateRoute();
    });

    dropAutocomplete.addListener('place_changed', function () {
      calculateRoute();
    });

    viaAutocomplete.addListener('place_changed', function () {
      calculateRoute();
    });

    viaTwoAutocomplete.addListener('place_changed', function () {
      calculateRoute();
    });
    
      viaThreeAutocomplete.addListener('place_changed', function () {
      calculateRoute();
    });

    viaFourAutocomplete.addListener('place_changed', function () {
      calculateRoute();
    });
    
     $(document).ready(function () {
      $('#routeSelect').change(function () {
          var routeType=$(this).val();
          if(routeType === 'return'){
              var pickupValue = $('#pickup').val();
              var dropoffValue = $('#drops').val();
             
              $('#via').val(dropoffValue);
              $('#drops').val(pickupValue);
              $('#pickup').val(pickupValue);
              calculateRoute();
            } 
            else if(routeType === 'oneway'){
              var via = $('#via').val();
             
              $('#drops').val(via);
              $('#via').val('');
              calculateRoute();
            }
          });
       });
  }



function addMarker(location, title, icon) {
  console.log(`Adding marker at ${location} with title: ${title} icon: ${icon}` );

  const marker = new google.maps.Marker({
    position: location,
    map: map,
    title: title,
    icon: './images/' + icon,
  });

  marker.setMap(map);
}
  function calculateRoute() {
    const pickupLocation = document.getElementById('pickup').value;
    const dropLocation = document.getElementById('drops').value;
    const viaLocation = document.getElementById('via').value;
    const viaLocationTwo = document.getElementById('viaTwo').value;
        const viaLocationThree = document.getElementById('viaThree').value  || null;;
    const viaLocationFour = document.getElementById('viaFour').value  || null;;

    if (!pickupLocation || !dropLocation) {
      return;
    }

    const mapIframe = document.getElementById('map');
    let googleMapsUrl;

if (!viaLocation && !viaLocationTwo) {
  googleMapsUrl = `https://www.google.com/maps/embed/v1/directions?key=AIzaSyBrT6TBKJor6uQd0OKXKzLnpkKY5JniO4M&origin=${pickupLocation}&destination=${dropLocation}`;
} else {
  const waypoints = [];

  if (viaLocation) {
    waypoints.push(viaLocation);
  }

  if (viaLocationTwo) {
    waypoints.push(viaLocationTwo);
  }

  if (viaLocationThree) {
    waypoints.push(viaLocationThree);
  }

  if (viaLocationFour) {
    waypoints.push(viaLocationFour);
  }

  googleMapsUrl = `https://www.google.com/maps/embed/v1/directions?key=AIzaSyBrT6TBKJor6uQd0OKXKzLnpkKY5JniO4M&origin=${pickupLocation}&destination=${dropLocation}&waypoints=${waypoints.join('|')}`;
}

mapIframe.src = googleMapsUrl;

    // let googleMapsUrl;

    // if (!viaLocation && !viaLocationTwo) {
    //   googleMapsUrl = `https://www.google.com/maps/embed/v1/directions?key=AIzaSyBu3_x5ycCqC5PfVeelGrvKe3t2t_Qz_TU&origin=${pickupLocation}&destination=${dropLocation}`;
    // } else {
    //   const waypoints = [];

    //   if (viaLocation) {
    //     waypoints.push({
    //       location: viaLocation,
    //       stopover: true,
    //     });
    //   }

    //   if (viaLocationTwo) {
    //     waypoints.push({
    //       location: viaLocationTwo,
    //       stopover: true,
    //     });
    //   }

    //   googleMapsUrl = `https://www.google.com/maps/embed/v1/directions?key=AIzaSyBu3_x5ycCqC5PfVeelGrvKe3t2t_Qz_TU&origin=${pickupLocation}&destination=${dropLocation}&waypoints=${waypoints.map((wp) => `via:${wp.location}`).join('|')}`;
    // }

    // mapIframe.src = googleMapsUrl;

    const request = {
      origin: pickupLocation,
      destination: dropLocation,
      travelMode: 'DRIVING',
      waypoints: [],
    };

    if (viaLocation) {
      request.waypoints.push({
        location: viaLocation,
        stopover: true,
      });
    }

    if (viaLocationTwo) {
      request.waypoints.push({
        location: viaLocationTwo,
        stopover: true,
      });
    }

    if (viaLocationThree) {
      request.waypoints.push({
        location: viaLocationThree,
        stopover: true,
      });
    }

    if (viaLocationFour) {
      request.waypoints.push({
        location: viaLocationFour,
        stopover: true,
      });
    }


    directionsService.route(request, function (result, status) {
    if (status == 'OK') {
        directionsRenderer.setDirections(result);

        let totalDistance = 0;
        let totalDuration = 0;

        const routes = result.routes;
        for (let i = 0; i < routes.length; i++) {
            const route = routes[i];

            for (let j = 0; j < route.legs.length; j++) {
                const leg = route.legs[j];

                // Accumulate total distance and duration
                totalDistance += leg.distance.value;
                totalDuration += leg.duration.value;

                // Set pickup and dropoff locations
                const pickupLat = leg.start_location.lat();
                const pickupLng = leg.start_location.lng();
                const dropoffLat = leg.end_location.lat();
                const dropoffLng = leg.end_location.lng();

                document.getElementById('pickupLocationLonLat').value = `${pickupLat},${pickupLng}`;
                document.getElementById('dropoffLocationLonLat').value = `${dropoffLat},${dropoffLng}`;

                // Add markers based on leg position
                if (j === 0) {
                    addMarker(leg.start_location, 'Pickup', 'https://maps.google.com/mapfiles/kml/paddle/P.png');
                }

                if (j === route.legs.length - 1) {
                    addMarker(leg.end_location, 'Drop', 'https://maps.google.com/mapfiles/kml/paddle/D.png');
                }

                if (j < route.legs.length - 1) {
                    addMarker(leg.end_location, `Via ${j + 1}`, 'https://maps.google.com/mapfiles/kml/paddle/wht-blank.png');
                }
            }
        }

        // Convert totalDistance to miles
        const totalDistanceInMiles = (totalDistance / 1609.344).toFixed(0);

        // Convert totalDuration to hours and minutes
       const totalMinutes = Math.floor(totalDuration / 60);
        const totalDurationText = `${totalMinutes} mins`;

        // Update distance and time input fields
        const inputDistance = document.getElementById('display_distance');
        inputDistance.value = `${totalDistanceInMiles} M`; // Format as "2 Mile"
        
        const inputTime = document.getElementById('Times');
        inputTime.value  = `${totalDurationText}`;
            
        const routeDiv = document.getElementById('routesummary');
                routeDiv.innerHTML = `
                    <p>Distance: ${totalDistanceInMiles} miles</p>&nbsp&nbsp
                    <p>Time: ${totalDurationText}</p>
                `;
        // Calculate and update additional details
        calculateDistanceAndFare();

    } else {
        alert("Error calculating the route");
    }
});
  }

  initMap();
});





function formatDate(date) {
  const year = date.getUTCFullYear();
  const month = String(date.getUTCMonth() + 1).padStart(2, '0'); // Month is zero-based
  const day = String(date.getUTCDate()).padStart(2, '0');
  return `${day}/${month}/${year}`;

}

function updateDate() {
  const currentDate = new Date();
  const formattedDate = formatDate(currentDate);
  document.getElementById('dateInput').value = formattedDate;
  document.getElementById('pickupDate').value = formattedDate;
  document.getElementById('retPickupDate').value = formattedDate;
}

// Function to get London time
function getLondonTime() {
  const options = {
    timeZone: 'Europe/London',
    hour12: false, 
    hour: '2-digit',
    minute: '2-digit',
  };
  const londonTime = new Date().toLocaleTimeString('en-US', options);
  return londonTime;
}

// Function to update the time input field with London time
function updateTime() {
  const londonTime = getLondonTime();
  document.getElementById('timeInput').value = londonTime;
  document.getElementById('pickupTime').value = londonTime;
  document.getElementById('returnPickupTime').value = londonTime;
}


updateDate();
updateTime();


let updateTimeInterval = setInterval(updateTime, 60000); // 60000ms = 1 minute


// Event listener for the .view button
$('.view, .edit, .onboardview, .onboardedit, .multijobs, .oneWay').on('click', function () {
    console.log("Hit view  button");
    clearInterval(updateTimeInterval);  
      document.getElementById('returnPickupTime').value = '';

  
  
});
    function clearMap(map) {
        // Remove route layer if it exists
        if (map.getLayer('route')) {
            map.removeLayer('route');
        }
        // Remove route source if it exists
        if (map.getSource('route')) {
            map.removeSource('route');
        }
    
        // Remove all existing markers
        const markers = document.querySelectorAll('.mapboxgl-marker');
        markers.forEach((marker) => marker.remove());
    
        // Fly the map back to Central London
        map.flyTo({
            center: [-0.1276, 51.5072], // Longitude and Latitude for Central London
            zoom: 12, // Adjust zoom level as needed
        });
    }

// Add event listeners for the buttons
document.getElementById('clear').addEventListener('click', () => {
    clearMap(map);
});

$('#clear, #returnTrip').on('click', function () {
  updateDate();
  updateTime();
  $("#newjobId").show();
  $("#jobId").hide();
});


  var pT = document.getElementById("Payment_Type");
  var Ac = document.getElementById("Account");
  console.log("dfhg", pT.value);

  pT.addEventListener("change", function () {
    if (pT.value === "Account") {
      // Enable the "Account" field
      Ac.disabled = false;
    } else {
      // Disable the "Account" field
      Ac.disabled = true;
    }
  });


  $(document).ready(function (){
    $('#addVia').click(function(){
      $('#viaTwo, #viaThree, #viaFour').toggle();
    });
  });

// $(document).ready(function(){
//   // Define the function to calculate fare
//   function calculateDistanceAndFare() {

//     // Retrieve location values from the form
//     var pickup = $('#pickup').val();
//     var drop = $('#drops').val();
//     var carType = $('#cartype').val();
//     var distance = $("#distance_display").val();
    
//     console.log("pickup", pickup)
//     console.log("drop", drop)
//     console.log("car", carType)
//     console.log("distance", distance)
    
    
//     if (pickup && drop) {
     
//             $.ajax({
//               type: 'POST',
//               url: './action/Submit.php',
//               data: {
//                 pickup: pickup,
//                 drop: drop,
//                 carType: carType,
//                 distance: distance
//               },
//               cache: false,
//               success: function (response) {
//                 console.log("response:", response);
//                 // Update the fare display with the calculated fare
//                 $('#priceVal').val( response);

//               },
//               error: function () {
//                 console.log("error")
//               }
//             });
//           } else {
//           console.log("dfdsfds")
//           }
//   }
  
//     // Add event listeners to car type, pickup location, and drop location inputs
//     $('#cartype, #pickup, #drops').on('input change', function () {
//       calculateDistanceAndFare();
//     });
  
//     // Initially, calculate the fare based on the initial values if both locations are provided
//     calculateDistanceAndFare();
// });
