$(document).ready(function () {
    let userShortcutKey = null;

    // Fetch the user's shortcut key from the database
    $.ajax({
        url: 'action/view_shortcutkey.php', // Adjust this URL as needed
        method: 'GET',
        success: function (data) { // Use 'data' directly as it is already parsed
           if (data.status === 'success' && data.data && data.data.map) {
                userShortcutKey = data.data.map; // Adjust to access nested 'map' key
                console.log('Shortcut key loaded:', userShortcutKey);

                // Ensure userShortcutKey is not null or undefined before using it
                if (userShortcutKey) {
                    // Attach the event listener dynamically
                    document.addEventListener("keydown", function (event) {
                        const shortcutKey = userShortcutKey.toLowerCase(); // Ensure comparison is case-insensitive
                        const key = event.key.toLowerCase(); // Get the key in lowercase

                        // Check if the shortcut is `Ctrl+key`
                        if (shortcutKey.includes("ctrl+") && event.ctrlKey && key === shortcutKey.replace("ctrl+", "")) {
                             event.preventDefault(); // Prevent any default behavior
                showMapModal();
                        }
                        // Check if the shortcut is `Alt+key`
                        else if (shortcutKey.includes("alt+") && event.altKey && key === shortcutKey.replace("alt+", "")) {
                             event.preventDefault(); // Prevent any default behavior
                showMapModal();
                        }
                        // Check if the shortcut is `Shift+key`
                        else if (shortcutKey.includes("shift+") && event.shiftKey && key === shortcutKey.replace("shift+", "")) {
                             event.preventDefault(); // Prevent any default behavior
                showMapModal();
                        }
                        // Check if the shortcut is `Meta+key` (Windows/Command key)
                        else if (shortcutKey.includes("meta+") && event.metaKey && key === shortcutKey.replace("meta+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                showMapModal();
                        }
                        // Handle the case where only the key is pressed (without modifier keys)
                        else if (event.key.toLowerCase() === shortcutKey) {
                             event.preventDefault(); // Prevent any default behavior
                showMapModal();
                        }
                    });
                } else {
                    console.error('Invalid shortcut key data:', data.map);
                }
            } else {
                console.error('Error loading shortcut key:', data.message || 'No Map key found');
            }
        },
        error: function (xhr, status, error) {
            console.error('AJAX error:', status, error);
        }
    });

    // Function to show the modal
   function showMapModal() {
            var myModal = new bootstrap.Modal(document.getElementById("exampleModalmap"), {});
            myModal.show();
        }
});

$(document).ready(function () {
    let userShortcutKey = null;

    // Fetch the user's shortcut key from the database
    $.ajax({
        url: 'action/view_shortcutkey.php', // Adjust this URL as needed
        method: 'GET',
        success: function (data) { // Use 'data' directly as it is already parsed
            if (data.status === 'success' && data.data && data.data.plot_drv) {
                userShortcutKey = data.data.plot_drv; // Adjust to access nested 'map' key
                console.log('Shortcut key loaded:', userShortcutKey);
                // Ensure userShortcutKey is not null or undefined before using it
                if (userShortcutKey) {
                    // Attach the event listener dynamically
                    document.addEventListener("keydown", function (event) {
                        const shortcutKey = userShortcutKey.toLowerCase(); // Ensure comparison is case-insensitive
                        const key = event.key.toLowerCase(); // Get the key in lowercase

                        // Check if the shortcut is `Ctrl+key`
                        if (shortcutKey.includes("ctrl+") && event.ctrlKey && key === shortcutKey.replace("ctrl+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            plot(); 
                        }
                        // Check if the shortcut is `Alt+key`
                        else if (shortcutKey.includes("alt+") && event.altKey && key === shortcutKey.replace("alt+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            plot(); 
                        }
                        // Check if the shortcut is `Shift+key`
                        else if (shortcutKey.includes("shift+") && event.shiftKey && key === shortcutKey.replace("shift+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            plot(); 
                        }
                        // Check if the shortcut is `Meta+key` (Windows/Command key)
                        else if (shortcutKey.includes("meta+") && event.metaKey && key === shortcutKey.replace("meta+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            plot(); 
                        }
                        // Handle the case where only the key is pressed (without modifier keys)
                        else if (event.key.toLowerCase() === shortcutKey) {
                            event.preventDefault(); // Prevent any default behavior
                            plot();  
                        }
                    });
                } else {
                    console.error('Invalid shortcut key data:', datd.data.plot_drv);
                }
            } else {
                console.error('Error loading shortcut key:', data.message || 'No plot_drv found');
            }
        },
        error: function (xhr, status, error) {
            console.error('AJAX error:', status, error);
        }
    });

    // Function to show the modal
    function plot() {
        var myModal = new bootstrap.Modal(document.getElementById("exampleModalPlot"), {});
        myModal.show();
    }
});


$(document).ready(function () {
    let userShortcutKey = null;

    // Fetch the user's shortcut key from the database
    $.ajax({
        url: 'action/view_shortcutkey.php', // Adjust this URL as needed
        method: 'GET',
        success: function (data) { // Use 'data' directly as it is already parsed
            if (data.status === 'success' && data.data && data.data.base) {
                userShortcutKey = data.data.base; // Adjust to access nested 'map' key
                console.log('Shortcut key loaded:', userShortcutKey);
                // Ensure userShortcutKey is not null or undefined before using it
                if (userShortcutKey) {
                    // Attach the event listener dynamically
                    document.addEventListener("keydown", function (event) {
                        const shortcutKey = userShortcutKey.toLowerCase(); // Ensure comparison is case-insensitive
                        const key = event.key.toLowerCase(); // Get the key in lowercase

                        // Check if the shortcut is `Ctrl+key`
                        if (shortcutKey.includes("ctrl+") && event.ctrlKey && key === shortcutKey.replace("ctrl+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            setJobTypeToBase();
                        }
                        // Check if the shortcut is `Alt+key`
                        else if (shortcutKey.includes("alt+") && event.altKey && key === shortcutKey.replace("alt+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                           setJobTypeToBase();
                        }
                        // Check if the shortcut is `Shift+key`
                        else if (shortcutKey.includes("shift+") && event.shiftKey && key === shortcutKey.replace("shift+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                          setJobTypeToBase();
                        }
                        // Check if the shortcut is `Meta+key` (Windows/Command key)
                        else if (shortcutKey.includes("meta+") && event.metaKey && key === shortcutKey.replace("meta+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            setJobTypeToBase();
                        }
                        // Handle the case where only the key is pressed (without modifier keys)
                        else if (event.key.toLowerCase() === shortcutKey) {
                            event.preventDefault(); // Prevent any default behavior
                           setJobTypeToBase();  
                        }
                    });
                } else {
                    console.error('Invalid shortcut key data:', datd.data.base);
                }
            } else {
                console.error('Error loading shortcut key:', data.message || 'No plot_drv found');
            }
        },
        error: function (xhr, status, error) {
            console.error('AJAX error:', status, error);
        }
    });

    // Function to show the modal
       function setJobTypeToBase() {
            // Set dropdown value to 'Base'
            $('#jobtype').val('Base').change(); 
        }
});

$(document).ready(function () {
    let userShortcutKey = null;

    // Fetch the user's shortcut key from the database
    $.ajax({
        url: 'action/view_shortcutkey.php', // Adjust this URL as needed
        method: 'GET',
        success: function (data) { // Use 'data' directly as it is already parsed
            if (data.status === 'success' && data.data && data.data.airport) {
                userShortcutKey = data.data.airport; // Adjust to access nested 'map' key
                console.log('Shortcut key loaded:', userShortcutKey);
                // Ensure userShortcutKey is not null or undefined before using it
                if (userShortcutKey) {
                    // Attach the event listener dynamically
                    document.addEventListener("keydown", function (event) {
                        const shortcutKey = userShortcutKey.toLowerCase(); // Ensure comparison is case-insensitive
                        const key = event.key.toLowerCase(); // Get the key in lowercase

                        // Check if the shortcut is `Ctrl+key`
                        if (shortcutKey.includes("ctrl+") && event.ctrlKey && key === shortcutKey.replace("ctrl+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                             setJobTypeToAirport();
                        }
                        // Check if the shortcut is `Alt+key`
                        else if (shortcutKey.includes("alt+") && event.altKey && key === shortcutKey.replace("alt+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            setJobTypeToAirport();
                        }
                        // Check if the shortcut is `Shift+key`
                        else if (shortcutKey.includes("shift+") && event.shiftKey && key === shortcutKey.replace("shift+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                           setJobTypeToAirport();
                        }
                        // Check if the shortcut is `Meta+key` (Windows/Command key)
                        else if (shortcutKey.includes("meta+") && event.metaKey && key === shortcutKey.replace("meta+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                             setJobTypeToAirport();
                        }
                        // Handle the case where only the key is pressed (without modifier keys)
                        else if (event.key.toLowerCase() === shortcutKey) {
                            event.preventDefault(); // Prevent any default behavior
                           setJobTypeToAirport();
                        }
                    });
                } else {
                    console.error('Invalid shortcut key data:', datd.data.airport);
                }
            } else {
                console.error('Error loading shortcut key:', data.message || 'No plot_drv found');
            }
        },
        error: function (xhr, status, error) {
            console.error('AJAX error:', status, error);
        }
    });

    // Function to show the modal
       function setJobTypeToAirport() {
            // Set dropdown value to 'Base'
            $('#jobtype').val('Airport').change(); 
        }
});

$(document).ready(function () {
    let userShortcutKey = null;

    // Fetch the user's shortcut key from the database
    $.ajax({
        url: 'action/view_shortcutkey.php', // Adjust this URL as needed
        method: 'GET',
        success: function (data) { // Use 'data' directly as it is already parsed
            if (data.status === 'success' && data.data && data.data.address) {
                userShortcutKey = data.data.address; // Adjust to access nested 'map' key
                console.log('Shortcut key loaded:', userShortcutKey);
                // Ensure userShortcutKey is not null or undefined before using it
                if (userShortcutKey) {
                    // Attach the event listener dynamically
                    document.addEventListener("keydown", function (event) {
                        const shortcutKey = userShortcutKey.toLowerCase(); // Ensure comparison is case-insensitive
                        const key = event.key.toLowerCase(); // Get the key in lowercase

                        // Check if the shortcut is `Ctrl+key`
                        if (shortcutKey.includes("ctrl+") && event.ctrlKey && key === shortcutKey.replace("ctrl+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            swapLocations();
                        }
                        // Check if the shortcut is `Alt+key`
                        else if (shortcutKey.includes("alt+") && event.altKey && key === shortcutKey.replace("alt+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            swapLocations();
                        }
                        // Check if the shortcut is `Shift+key`
                        else if (shortcutKey.includes("shift+") && event.shiftKey && key === shortcutKey.replace("shift+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                          swapLocations();
                        }
                        // Check if the shortcut is `Meta+key` (Windows/Command key)
                        else if (shortcutKey.includes("meta+") && event.metaKey && key === shortcutKey.replace("meta+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                             swapLocations();
                        }
                        // Handle the case where only the key is pressed (without modifier keys)
                        else if (event.key.toLowerCase() === shortcutKey) {
                            event.preventDefault(); // Prevent any default behavior
                            swapLocations();  
                        }
                    });
                } else {
                    console.error('Invalid shortcut key data:', datd.data.address);
                }
            } else {
                console.error('Error loading shortcut key:', data.message || 'No plot_drv found');
            }
        },
        error: function (xhr, status, error) {
            console.error('AJAX error:', status, error);
        }
    });

function swapLocations() {
  
    var pickupInput = document.getElementById('pickup');
    var dropoffInput = document.getElementById('drops');
    
    // Swap the values
    var temp = pickupInput.value;
    pickupInput.value = dropoffInput.value;
    dropoffInput.value = temp;
}
});

$(document).ready(function () {
    let userShortcutKey = null;

    // Fetch the user's shortcut key from the database
    $.ajax({
        url: 'action/view_shortcutkey.php', // Adjust this URL as needed
        method: 'GET',
        success: function (data) { // Use 'data' directly as it is already parsed
            if (data.status === 'success' && data.data && data.data.via) {
                userShortcutKey = data.data.via; // Adjust to access nested 'map' key
                console.log('Shortcut key loaded:', userShortcutKey);
                // Ensure userShortcutKey is not null or undefined before using it
                if (userShortcutKey) {
                    // Attach the event listener dynamically
                    document.addEventListener("keydown", function (event) {
                        const shortcutKey = userShortcutKey.toLowerCase(); // Ensure comparison is case-insensitive
                        const key = event.key.toLowerCase(); // Get the key in lowercase

                        // Check if the shortcut is `Ctrl+key`
                        if (shortcutKey.includes("ctrl+") && event.ctrlKey && key === shortcutKey.replace("ctrl+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            addvia();
                        }
                        // Check if the shortcut is `Alt+key`
                        else if (shortcutKey.includes("alt+") && event.altKey && key === shortcutKey.replace("alt+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            addvia();
                        }
                        // Check if the shortcut is `Shift+key`
                        else if (shortcutKey.includes("shift+") && event.shiftKey && key === shortcutKey.replace("shift+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                          addvia();
                        }
                        // Check if the shortcut is `Meta+key` (Windows/Command key)
                        else if (shortcutKey.includes("meta+") && event.metaKey && key === shortcutKey.replace("meta+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                             addvia();
                        }
                        // Handle the case where only the key is pressed (without modifier keys)
                        else if (event.key.toLowerCase() === shortcutKey) {
                            event.preventDefault(); // Prevent any default behavior
                            addvia();  
                        }
                    });
                } else {
                    console.error('Invalid shortcut key data:', datd.data.via);
                }
            } else {
                console.error('Error loading shortcut key:', data.message || 'No plot_drv found');
            }
        },
        error: function (xhr, status, error) {
            console.error('AJAX error:', status, error);
        }
    });

             function addvia() {
            // Set dropdown value to 'Base'
            var myModal = new bootstrap.Modal(document.getElementById("exampleModal"), {});
            myModal.show();
        }
});

$(document).ready(function () {
    let userShortcutKey = null;

    // Fetch the user's shortcut key from the database
    $.ajax({
        url: 'action/view_shortcutkey.php', // Adjust this URL as needed
        method: 'GET',
        success: function (data) { // Use 'data' directly as it is already parsed
            if (data.status === 'success' && data.data && data.data.booking) {
                userShortcutKey = data.data.booking; // Adjust to access nested 'map' key
                console.log('Shortcut key loaded:', userShortcutKey);
                // Ensure userShortcutKey is not null or undefined before using it
                if (userShortcutKey) {
                    // Attach the event listener dynamically
                    document.addEventListener("keydown", function (event) {
                        const shortcutKey = userShortcutKey.toLowerCase(); // Ensure comparison is case-insensitive
                        const key = event.key.toLowerCase(); // Get the key in lowercase

                        // Check if the shortcut is `Ctrl+key`
                        if (shortcutKey.includes("ctrl+") && event.ctrlKey && key === shortcutKey.replace("ctrl+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            multi_booking();
                        }
                        // Check if the shortcut is `Alt+key`
                        else if (shortcutKey.includes("alt+") && event.altKey && key === shortcutKey.replace("alt+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                            multi_booking();
                        }
                        // Check if the shortcut is `Shift+key`
                        else if (shortcutKey.includes("shift+") && event.shiftKey && key === shortcutKey.replace("shift+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                          multi_booking();
                        }
                        // Check if the shortcut is `Meta+key` (Windows/Command key)
                        else if (shortcutKey.includes("meta+") && event.metaKey && key === shortcutKey.replace("meta+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                             multi_booking();
                        }
                        // Handle the case where only the key is pressed (without modifier keys)
                        else if (event.key.toLowerCase() === shortcutKey) {
                            event.preventDefault(); // Prevent any default behavior
                            multi_booking();  
                        }
                    });
                } else {
                    console.error('Invalid shortcut key data:', datd.data.booking);
                }
            } else {
                console.error('Error loading shortcut key:', data.message || 'No plot_drv found');
            }
        },
        error: function (xhr, status, error) {
            console.error('AJAX error:', status, error);
        }
    });

             function multi_booking() {
            // Set dropdown value to 'Base'
            var myModal = new bootstrap.Modal(document.getElementById("exampleModalMulti"), {});
            myModal.show();
        }
});



$(document).ready(function () {
    let userShortcutKey = null;

    // Fetch the user's shortcut key from the database
    $.ajax({
        url: 'action/view_shortcutkey.php', // Adjust this URL as needed
        method: 'GET',
        success: function (data) { // Use 'data' directly as it is already parsed
            if (data.status === 'success' && data.data && data.data.history) {
                userShortcutKey = data.data.history; // Adjust to access nested 'map' key
                console.log('Shortcut key loaded:', userShortcutKey);
                // Ensure userShortcutKey is not null or undefined before using it
                if (userShortcutKey) {
                    // Attach the event listener dynamically
                    document.addEventListener("keydown", function (event) {
                        const shortcutKey = userShortcutKey.toLowerCase(); // Ensure comparison is case-insensitive
                        const key = event.key.toLowerCase(); // Get the key in lowercase

                        // Check if the shortcut is `Ctrl+key`
                        if (shortcutKey.includes("ctrl+") && event.ctrlKey && key === shortcutKey.replace("ctrl+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                             fetchUserHistory();
                booking_history();
                        }
                        // Check if the shortcut is `Alt+key`
                        else if (shortcutKey.includes("alt+") && event.altKey && key === shortcutKey.replace("alt+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                              fetchUserHistory();
                booking_history();
                        }
                        // Check if the shortcut is `Shift+key`
                        else if (shortcutKey.includes("shift+") && event.shiftKey && key === shortcutKey.replace("shift+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                           fetchUserHistory();
                booking_history();
                        }
                        // Check if the shortcut is `Meta+key` (Windows/Command key)
                        else if (shortcutKey.includes("meta+") && event.metaKey && key === shortcutKey.replace("meta+", "")) {
                            event.preventDefault(); // Prevent any default behavior
                              fetchUserHistory();
                booking_history();
                        }
                        // Handle the case where only the key is pressed (without modifier keys)
                        else if (event.key.toLowerCase() === shortcutKey) {
                            event.preventDefault(); // Prevent any default behavior
                              fetchUserHistory();
                             booking_history();  
                        }
                    });
                } else {
                    console.error('Invalid shortcut key data:', datd.data.history);
                }
            } else {
                console.error('Error loading shortcut key:', data.message || 'No plot_drv found');
            }
        },
        error: function (xhr, status, error) {
            console.error('AJAX error:', status, error);
        }
    });

                          function booking_history() {
            // Set dropdown value to 'Base'
            var myModal = new bootstrap.Modal(document.getElementById("exampleModalhistory"), {});
            myModal.show();
        }
        function fetchUserHistory() {
        var phone = $('#phone').val();
        console.log(phone);
        $.ajax({
            type: 'post',
            url: 'action/history.php',
            data: { phone: phone },
            dataType: 'json',
            success: function (data) {
                console.log(data);
                var tableBody = $('#userjobHistoryTable tbody');

                if (data.length > 0) {
                    tableBody.empty();
                    $.each(data, function (index, item) {
                        var dateParts = item.date.split('/');
                        var formattedDate =
                            dateParts[1] + '/' + dateParts[0] + '/' + dateParts[2];
                        tableBody.append(
                            '<tr>' +
                                '<td>' +
                                item.id +
                                '</td>' +
                                '<td>' +
                                formattedDate +
                                '</td>' +
                                '<td>' +
                                item.pickup +
                                '</td>' +
                                '<td>' +
                                item.dropoff +
                                '</td>' +
                                '<td>' +
                                item.distance +
                                '</td>' +
                                '<td>' +
                                item.fare +
                                '</td>' +
                                '<td>' +
                                item.phone +
                                '</td>' +
                                '<td>' +
                                item.name +
                                '</td>' +
                                '<td>' +
                                item.payment_type +
                                '</td>' +
                                '<td>' +
                                item.dispatch_DriverId +
                                '</td>' +
                                '</tr>'
                        );
                    });
                } else {
                    console.log('No data found.');
                }
            },
        });
    }
});

