<?php
session_start();
require __DIR__ . "/vendor/autoload.php";

use Dompdf\Dompdf;
use Dompdf\Options;
$user_id= $_SESSION['user_tenant_id'];
$table1 = isset($_GET['table1']) ? json_decode($_GET['table1'], true) : [];
$table2 = isset($_GET['table2']) ? json_decode($_GET['table2'], true) : [];
$invoice_no = isset($_GET['invoice_no']) ? htmlspecialchars($_GET['invoice_no']) : 'N/A';
$invoice_date = isset($_GET['invoice_date']) ? htmlspecialchars($_GET['invoice_date']) : 'N/A';

if (!empty($table1) || !empty($table2)) {
    include('db/db.php');
    $query = "SELECT * FROM `users` WHERE user_tenant_id='$user_id'";
    $result = mysqli_query($con, $query);
    
    if ($result && mysqli_num_rows($result) > 0) {
        $heading = mysqli_fetch_assoc($result);
        $website=["website"];
        $Email=["email"];
        $address=["address"];
        $cleanedPath = str_replace("..", "https://cabmaster.live/superAdmin", $heading["company_logo"]);
        $fullPath = $cleanedPath;
        // echo $fullPath;
    $html = '<html>
    <head>
    <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css" rel="stylesheet">
    <style>
    @page {
        margin: 30px;
    }
    footer {
        position: fixed;
        bottom: 10px;
        left: 0;
        right: 0;
        text-align: center;
        font-size: 12px;
        color: black;
        font-size:20px
    }
    .first {
        border-collapse: collapse;
        border: 1px solid black;
    }

    .first th, .first td {
        border: 1px solid black;
    }
    
    .second {
        border-collapse: collapse;
        border: 1px solid black;
    }

    .second th, .second td {
        border: 1px solid black;
    }
         img {
            width: 200px;
            height: 200px;
            margin-right: 20px;
        }
        .col-md-5{
position: absolute;
    left: 798px;
          top:20px; 
          
        }
        p{
               font-weight: 700;
        }
</style>

    <body>';
    $html .= '<div class="container-fluid">
    <div class="row align-items-center"> <!-- align-items-center for vertical centering -->
        <div class="col-md-6">
            <img src="' . htmlspecialchars($fullPath) . '" alt="Company Logo" class="border">
        </div>
        <div class="col-md-5">
            <p>Invoice No: ' . $invoice_no . '</p>
            <p>Invoice Date: ' . $invoice_date . '</p>
            <p>Name: <span>' . htmlspecialchars($heading["Name"]) . '</span></p>
            <p>Telephone: <span>' . htmlspecialchars($heading["telephone"]) . '</span></p>
        </div>
    </div>
  </div>';

    $html .= '<h2 style="color:#1556adb8;text-align:center;margin:30px 0px;">Passenger Invoice</h2>';

    // Table 1: First table data
    $html .= '<table class="first" style="width: 100%; margin-bottom: 20px;text-align:center; border-collapse: collapse; border: 1px solid black;">';
    $html .= '<thead>';
    $html .= '<tr>';
    $html .= '<th style="background-color: #1556adb8; border: 1px solid black;">Passenger Name</th>';
    $html .= '<th style="background-color: #1556adb8; border: 1px solid black;">Phone</th>';
    $html .= '<th style="background-color: #1556adb8; border: 1px solid black;">Job Type</th>';
    $html .= '</tr>';
    $html .= '</thead>';
    $html .= '<tbody>';
    foreach ($table1 as $row) {
        $html .= '<tr>';
        foreach ($row as $cell) {
            $html .= '<td style="border: 1px solid black;">' . htmlspecialchars($cell) . '</td>';
        }
        $html .= '</tr>';
    }
    $html .= '</tbody>';
    $html .= '</table>';

    // Table 2: Second table data
    $html .= '<table class="second" style="width: 100%; margin-bottom: 100px;text-align:center; border-collapse: collapse; border: 1px solid black;">';
    $html .= '<thead>';
    $html .= '<tr>';
    $html .= '<th style="background-color: #1556adb8; border: 1px solid black;">Date and Time</th>';
    $html .= '<th style="background-color: #1556adb8; border: 1px solid black;">Pickup</th>';
    $html .= '<th style="background-color: #1556adb8; border: 1px solid black;">Dropoff</th>';
    $html .= '<th style="background-color: #1556adb8; border: 1px solid black;">Fare</th>';
    $html .= '</tr>';
    $html .= '</thead>';
    $html .= '<tbody>';
    foreach ($table2 as $row) {
        $html .= '<tr>';
        foreach ($row as $cell) {
            $html .= '<td style="border: 1px solid black;">' . htmlspecialchars($cell) . '</td>';
        }
        $html .= '</tr>';
    }
    $html .= '</tbody>';
    $html .= '</table>';
    $html .= ' <footer>
        <p>
            <span><i class="fas fa-envelope"></i> ' . htmlspecialchars($heading["Email"]) . '</span> | 
            <span><i class="fas fa-globe"></i> ' . htmlspecialchars($heading["website"]) . '</span>
        </p>
        <p><i class="fas fa-map-marker-alt"></i> ' . htmlspecialchars($heading["address"]) . '</p>
    </footer>';

    $html .= '</body></html>';

 $options = new Options;
        $options->set('isRemoteEnabled', true);
        $options->setChroot(__DIR__);
        $options->setIsHtml5ParserEnabled(true);
        $options->setIsPhpEnabled(true);

        $dompdf = new Dompdf($options);
        $dompdf->setPaper("A4", "landscape");
        $dompdf->loadHtml($html);

        $dompdf->render();

        $pdfOutput = $dompdf->output();
        header('Content-Type: application/pdf');
        header('Content-Disposition: attachment; filename="Cash_Invoice.pdf"');
        header('Cache-Control: private, max-age=0, must-revalidate');
        header('Pragma: public');
        header('Expires: Sat, 26 Jul 1997 05:00:00 GMT');
        header('Content-Length: ' . strlen($pdfOutput));

        echo $pdfOutput;
} else {
    echo 'Error: Failed to retrieve heading data.';
}
} else {
    echo 'Error: Insufficient data received.';
}
?>