
<!-- Custom Popup -->
<div id="driverExpiryPopup" class="expiry-popup custom-popup" style="display: none;">
    <div class="expiry-popup-content">
        <div class="expiry-header background">
        <span id="closeExpiryPopup" class="expiry-close-popup">&times;</span>
        <h4>Driver Document Expiry</h4>
        </div>
        <div class="expiry-popup-table-content" style="overflow:scroll;height:120px;">
            <?php
            include('../db/db.php');
            $user_id = $_SESSION['user_tenant_id'];
            $daysThreshold = 30;
            $currentDate = date("d/m/Y");

            // Query to fetch drivers and check expiry
            $query_expiry = "SELECT * FROM `drivers` WHERE user_tenant_id='$user_id'";
            $result_expiry = mysqli_query($con, $query_expiry);

            if ($result_expiry) {
                echo '<table class="expiry-table display table table-striped table-bordered dataTable no-footer">
                    <thead class="background" style="font-family: poppins;">
                        <tr class="background">
                            <th>Driver ID</th>
                            <th>Driver Name</th>
                            <th>VRM</th>
                            <th>MOT Expiry</th>
                            <th>Insurance Expiry</th>
                            <th>PCO (Vehicle) Expiry</th>
                        </tr>
                    </thead>
                    <tbody style="font-family: poppins;">';
                
                while ($row_expiry = mysqli_fetch_assoc($result_expiry)) {
                    $name = $row_expiry['Name'];
                    $id = $row_expiry['Driver_id'];
                    $vrm = $row_expiry['Registration']; // VRM value
                    $mot = $row_expiry['MOT_Epiry'];
                    $ins = $row_expiry['Insurance_Expiry'];
                    $pco = $row_expiry['Vehicle_PCO_Expiry'];

                    // Calculate remaining days for expiry
                    $motDays = (strtotime($mot) - strtotime($currentDate)) / (60 * 60 * 24);
                    $insDays = (strtotime($ins) - strtotime($currentDate)) / (60 * 60 * 24);
                    $pcoDays = (strtotime($pco) - strtotime($currentDate)) / (60 * 60 * 24);

                    // Check if any expiry is within the threshold
                    if (($motDays <= $daysThreshold && $motDays >= 0) ||
                        ($insDays <= $daysThreshold && $insDays >= 0) ||
                        ($pcoDays <= $daysThreshold && $pcoDays >= 0)) {
                        
                        echo "<tr>
                            <td>{$id}</td>
                            <td>{$name}</td>
                            <td>{$vrm}</td>
                            <td>{$mot}</td>
                            <td>{$ins}</td>
                            <td>{$pco}</td>
                        </tr>";
                     }
                     
                }
                echo '</tbody></table>';
            } else {
                echo '<p>Error fetching data: ' . mysqli_error($con) . '</p>';
            }
            ?>
        </div>
    </div>
</div>

<!-- Styles for the Custom Popup -->
<style>
    .expiry-popup {
        position: fixed;
        top: 25%;
        left: 50%;
        transform: translate(-50%, -50%);
        width: 45%;
        background: #fff;
        box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);
        padding: 0px;
        z-index: 9999;
        overflow: auto;
        max-height: 80vh;
    }

    .expiry-popup-content {
        position: relative;
        text-align: center;
    }

    .expiry-popup-table-content {
        margin-top: 5px;
    }

    .expiry-table {
        width: 100%;
        border-collapse: collapse;
    }

    .expiry-table th, .expiry-table td {
        padding: 10px;
        text-align: left;
        border: 1px solid #ddd;
    }

    .expiry-table th {
        background:<?php echo($row['navbar_color'])?>!important ;
        color:<?php echo ($row['font_color']) ?> !important;
        font-family: <?php echo($row['themefont_family'])?>!important;
    }

.expiry-close-popup {
    position: absolute;
    top: 5px;
    right: 13px;
    cursor: pointer;
    font-size: 18px;
    font-weight: 500;
    color: white;
}
    .expiry-header{
        height:32px;
    }
</style>

<!-- Script to Show Popup After 6 Hours -->
<script>
    // Check if a timestamp is already set
    let expiryTimestamp = localStorage.getItem("expiryPopupTime");

    if (!expiryTimestamp) {
        // If not set, calculate the timestamp for 2 minutes from now
      expiryTimestamp = Date.now() + 6 * 60 * 60 * 1000; 
        localStorage.setItem("expiryPopupTime", expiryTimestamp);
    }

    // Function to check if it's time to show the popup
    function checkPopup() {
        const currentTime = Date.now();

        if (currentTime >= expiryTimestamp) {
            // Show the popup
            document.getElementById("driverExpiryPopup").style.display = "block";
            // Remove the timestamp to avoid re-triggering
            localStorage.removeItem("expiryPopupTime");
        } else {
            // Check again after a short delay
            setTimeout(checkPopup, 1000); // Check every second
        }
    }
document.getElementById("closeExpiryPopup").addEventListener("click", function () {
            document.getElementById("driverExpiryPopup").style.display = "none";
        });
    // Call the function on page load
    checkPopup();
</script>

