<?php
include("db/db.php"); // Include database connection

// Check if the user is logged in
if (!isset($_SESSION['log'])) {
    header("Location: ./login.php");
    exit;
}

$role = $_SESSION['admin']; // Fetch the role from the session
$userId = $_SESSION['user_id']; // Fetch the user ID
$isFromUserTable = $_SESSION['is_from_user_table']; // Flag to know if the user is from user table or company_user table


// Define icons for each page
$icons = [
     'Dashboard' => 'assets/images/dashboard_icon.png',
    'Management' => 'assets/images/Manage_Icon.png',
    'Jobs' => 'assets/images/Jobs_Icon.png',
    'Drivers' => 'assets/images/Driver_Icon.png',
    'Reports' => 'assets/images/Reports_Icon.png',
    'Accounts' => 'assets/images/Accounts.png',
    'Plotting' => 'assets/images/plotting_icon.png',
    'Tracking' => 'assets/images/Navigation_3d.png',
    'Customer' => 'assets/images/Customer_icon.png',
    'Logs' => 'assets/images/Call_Log_Icon.png',
    'Setting' => 'assets/images/Settings_icon.png',
    'Logout' => 'assets/images/logout.png'
];

// Case 1: If admin is from the user table, show all buttons
if ($isFromUserTable && $role == 1) {
    $pages = [
        'Dashboard' => 'index.php',
        'Management' => 'fare.php',
        'Jobs' => 'Jobs.php',
        'Drivers' => 'drivers.php',
        'Reports' => 'earning.php',
        'Accounts' => 'accounts.php',
        'Plotting' => 'Plot.php',
        'Tracking' => 'driverTracking.php',
        'Customer' => 'customer_list.php',
        'Logs' => 'call_log_history.php',
        'Setting' => 'config.php',
        'Logout' => './action/logout.php'
    ];
} else {
    // Case 2: Admin is from company_user table, check their role and allowed pages
    $pages = [];
    $query = "SELECT * FROM company_user WHERE id = ? AND role = ?";
    $stmt = $con->prepare($query);
    $stmt->bind_param('ii', $userId, $role);
    $stmt->execute();
    $result = $stmt->get_result();
    $permissions = $result->fetch_assoc();

    if ($permissions) {
        // Based on the fetched permissions, display only allowed links
        if ($permissions['dasboard'] == 1) $pages['Dashboard'] = 'index.php';
        if ($permissions['management'] == 1) $pages['Management'] = 'fare.php';
        if ($permissions['job'] == 1) $pages['Jobs'] = 'Jobs.php';
        if ($permissions['driver'] == 1) $pages['Drivers'] = 'drivers.php';
        if ($permissions['report'] == 1) $pages['Reports'] = 'earning.php';
        if ($permissions['account'] == 1) $pages['Accounts'] = 'accounts.php';
        if ($permissions['plottings'] == 1) $pages['Plotting'] = 'Plot.php';
        if ($permissions['tracking'] == 1) $pages['Tracking'] = 'driverTracking.php';
        if ($permissions['customer'] == 1) $pages['Customer'] = 'customer_list.php';
        if ($permissions['settings'] == 1) $pages['Setting'] = 'config.php';
    }

    // Logout link is always available
    $pages['Logout'] = './action/logout.php';
}

?>
<!-- Styles -->
<style>
    .navbars .container-fluid .col-12 .navbar-list li a {
        color: <?php echo $row['navbar_font']?> !important;
        font-family: <?php echo $row['navbarfont_family']?> !important;
    }
    i {
        color: <?php echo $row['icon_color']?> !important;
    }
    .navbars .container-fluid .col-12 .navbar-list li a {
        text-decoration: none;
        color: #c2c7d0;
        font-weight: 700;
    }
    .logout-item {
        margin-left: auto; /* Push logout to the right */
    }

.count_data {
     /*background-color: #ffde59; */
    /*background-color: #ffff00 !important;*/
    color: black;
    font-size: 13px;
    /*padding: 10px 12px;*/

}
  .count_data marquee{
        color: <?php echo $row['driver_color']?> !important;
        padding: 13px 5px;
    }
  .count_data {
       background-color: <?php echo $row['driver_bg_color']?> !important;
    }
.navbars {
    padding: 10px 10px !important;
}
        .navbars .container-fluid .col-12 .navbar-list li a{
        font-size:23px;
        border:1px solid <?php echo $row['navbar_font']?> !important;
        padding: 8px 12px;
        border-radius: 5px;
        box-shadow:0px 0px 7px <?php echo $row['navbar_font']?> !important;
    }
.navbars .container-fluid .col-12 .navbar-list li {
    list-style-type: none;
    margin-right: 10px;
}
.navbars .container-fluid .col-12 .navbar-list li {
    list-style-type: none;
    margin-right: 10px;
    padding:;
}
</style>

<!-- Navbar -->
<nav class="navbars" style="background:<?php echo $row['navbar_color']?> !important">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <div class="content">
                    <div class="list-box">
                        <ul class="navbar-list">
                            <?php foreach ($pages as $name => $link): ?>
                                <?php if ($name != 'Logout'): // Separate Logout item ?>
                                    <li>
                                        <a href="<?php echo $link; ?>">
                                            <span title="<?php echo $name; ?>"><img src="<?php echo $icons[$name]; ?>" style="width: 35px"></span>
                                            <!--<span></span>-->
                                        </a>
                                    </li>
                                <?php endif; ?>
                            <?php endforeach; ?>
                             <li class="count_data " style="display: flex; align-items: center;">
                               
                                <marquee style="font-weight:700;">
                                    
                                        Driver On Job:
                                        <span class="onboard_count">0</span>
                                   
                              
                                        &nbsp;Soon To Clear:
                                        <span class="status_count">0</span>
                                    
                                    
                                        &nbsp;Waiting On Plot:
                                        <span class="available_count">0</span>
                                    
                                </marquee>
                              
                            </li>
                             <li class="logout-item" >
                                  <a href="#" class="color-li" onclick="toggleCallDetails()">
                                      <span title="Call Popup"><img src="assets/images/call_popup_icon.png" style="width: 35px"></span>
                                  </a>      
                            </li>
                             <li class="" >
                                  <a href="#" class="color-li" onclick="toggleChatPopup()">
                                       <span title="Chat Popup"><img src="assets/images/chat_icon.png" style="width: 35px"></span>
                                  </a>      
                            </li>
                            <li class=""> <!-- Special class for Logout -->
                                <a href="<?php echo $pages['Logout']; ?>">
                                    <span title="Logout"><img src="<?php echo $icons['Logout']; ?>" style="width: 35px"></span>
                                   <!--<span>Logout</span>-->
                                </a>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </div>
</nav>
