<?php

include("../db/db.php");

if (isset($_POST['submit'])) {
    // Initialize variables from POST data
        $company_type = $_POST['company_type_select'] ?? '';
    $user_id = $_POST['user_tenant_id'] ?? '';
    $role = 1;
    $status = $_POST['status'] ?? '';
    $password = $_POST['password'] ?? '';
    $name = $_POST['campany_name'] ?? '';
    $company = $_POST['company'] ?? '';
    $telephone = $_POST['telephone'] ?? '';
    $email = $_POST['email'] ?? '';
    $address = $_POST['address'] ?? '';
    $postcode = $_POST['postcode'] ?? '';
    $website = $_POST['website'] ?? '';
    $city = $_POST['city'] ?? '';
    $country = $_POST['country'] ?? '';
    $vat = $_POST['vat'] ?? '';
    $license = $_POST['license'] ?? '';
    $reg_no = $_POST['reg_no'] ?? '';
    $subject = $_POST['subject'] ?? '';
    $invoice_body = $_POST['invoice_body'] ?? '';
    $invoice_text = $_POST['invoice_text'] ?? '';
    $drv_email_subject = $_POST['drv_email_subject'] ?? '';
    $drv_email_body = $_POST['drv_email_body'] ?? '';
    $drv_statement_text = $_POST['drv_statement_text'] ?? '';
    $selectedCompanyTypes = $_POST['company_type'];
    $companyTypesString = implode(',', $selectedCompanyTypes);
    $date = $_POST['date'] ?? '';
    $package = $_POST['package'] ?? '';
    $uploadDir = "../assets/upload/";

    // Handle file upload
    $companyLogoPath = '';
    if (isset($_FILES['company_logo']) && $_FILES['company_logo']['error'] == UPLOAD_ERR_OK) {
        $companyLogo = basename($_FILES['company_logo']['name']);
        $companyLogoFilePath = $uploadDir . $companyLogo;

        if (move_uploaded_file($_FILES['company_logo']['tmp_name'], $companyLogoFilePath)) {
            $companyLogoPath = $companyLogoFilePath;
        } else {
            echo "Error uploading logo file.";
            exit;
        }
    }

    // Check for duplicate user_tenant_id and generate unique one if needed
    if (!empty($user_id)) {
        $stmt = $con->prepare("SELECT COUNT(*) AS count FROM users WHERE user_tenant_id = ?");
        $stmt->bind_param("s", $user_id);
        $stmt->execute();
        $result = $stmt->get_result();
        $row = $result->fetch_assoc();

        if ($row['count'] > 0) {
            $user_id = generateUniqueKey($con);
        }
        $stmt->close();
    }

    // Generate unique key
    function generateKey() {
        $alphabets = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
        $symbols = "_!@#$%^&*()-+=<>?";
        $digits = "0123456789";

        $generatedKey = '';
        for ($i = 0; $i < 2; $i++) {
            $generatedKey .= $alphabets[rand(0, strlen($alphabets) - 1)];
        }
        $generatedKey .= $symbols[rand(0, strlen($symbols) - 1)];
        for ($i = 0; $i < 5; $i++) {
            $generatedKey .= $digits[rand(0, strlen($digits) - 1)];
        }

        return $generatedKey;
    }

    function generateUniqueKey($con) {
        do {
            $newKey = generateKey();
            $stmt = $con->prepare("SELECT COUNT(*) AS count FROM users WHERE user_tenant_id = ?");
            $stmt->bind_param("s", $newKey);
            $stmt->execute();
            $result = $stmt->get_result();
            $row = $result->fetch_assoc();
            $isUnique = ($row['count'] == 0);
            $stmt->close();
        } while (!$isUnique);

        return $newKey;
    }

    // Insert or update the user record
    if (isset($_POST['editId']) && !empty($_POST['editId'])) {
        $editId = $_POST['editId'];
        $stmt = $con->prepare("UPDATE users SET Name = ?, Email = ?, Password = ?, Role = ?, telephone = ?, reg_no = ?, vat = ?, address = ?, country = ?, city = ?, postcode = ?, subject = ?, invoice_body = ?, drv_email_subject = ?, drv_email_body = ?, drv_statement_text = ?, invoice_text = ?, status = ?, company_logo = ?, license = ? WHERE id = ? AND user_tenant_id = ?");
        $stmt->bind_param("ssssssssssssssssssssis", $name, $email, $password, $role, $telephone, $reg_no, $vat, $address, $country, $city, $postcode, $subject, $invoice_body, $drv_email_subject, $drv_email_body, $drv_statement_text, $invoice_text, $status, $companyLogoPath, $license, $editId, $user_id);
        $stmt->execute();
        header("Location: ../create_company.php");
        exit();
         $stmt->close();
    } else {
        $stmt = $con->prepare("INSERT INTO users (company_name, Name, Email, Password, Role, user_tenant_id, telephone, reg_no, vat, address, country, city, postcode, subject, invoice_body, drv_email_subject, drv_email_body, drv_statement_text, invoice_text, status, company_logo, license, website, package, join_date, company_type, vehicle_type) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
        $stmt->bind_param("sssssssssssssssssssssssssss", $company, $name, $email, $password, $role, $user_id, $telephone, $reg_no, $vat, $address, $country, $city, $postcode, $subject, $invoice_body, $drv_email_subject, $drv_email_body, $drv_statement_text, $invoice_text, $status, $companyLogoPath, $license, $website, $package, $date, $company_type, $companyTypesString);
    if ($stmt->execute()) {
        // Insert default settings
        $queryDefault = "INSERT INTO setting (navbar_color, font_color, navbar_font, scroll_color, navbarfont_family, themefont_family, icon_color, notification_color, pickup_color, onboard_job, on_route_color, soon_to_clear, back_list, driver_bg_color, driver_color, user_tenant_id) VALUES ('#6f42c1', 'White', '#c2c7d0', '#6f42c1', 'Montserrat', 'Montserrat', '#', '#6f42c1', '#', '#', '#', '#', '#', '#ffde59', 'black', ?)";
        $stmtDefault = $con->prepare($queryDefault);
        $stmtDefault->bind_param("s", $user_id);
        $stmtDefault->execute();

        // Insert user preferences
        $queryPreferences = "INSERT INTO user_preferences (background_color, text_color, cash_color, account_color, card_color, basecolor, schoolcolor, driver_waiting, onBoard, airport_color, waitingcolor, OnBoard_font, user_tenant_id) VALUES ('#', '#', '#', '#', '#', '#', '#', '#', '#', '#', '#', '#', ?)";
        $stmtPreferences = $con->prepare($queryPreferences);
        $stmtPreferences->bind_param("s", $user_id);
        $stmtPreferences->execute();

        header("Location: ../create_company.php");
        exit;
    } else {
        echo "Failed to save to database: " . $stmt->error;
    }
   }
    $stmt->close();
}
?>
